function Veiculos() {
	const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	const z = new ZeedhiAPIConstructor(browser, protractor);
	const Helper = require('teknisa-helper');
	const geral = new Helper.geral();
	self = this;
	const protractorHelper = require('protractor-helper');
	this.veiculosGridId = () => '12356333192634658038958';

	this.abrir = () => {
		z.component.menu.open();
		protractorHelper.waitForElementVisibility(element(by.css('.menu-overlay')));
		z.component.menu.clickByPath(['Parametrização', 'Expedição', 'Veículos']);
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${self.veiculosGridId()}`)));
	};

	this.adicionar = (codigo, placa, manutencao, nome, municipio, estado, transportadora, capacidadeKg,
		frete, volume, tara, tipoDeRodado, tipoProprietario, tipoDeCarroceria, capacidadeCaixa, motorista) => {
		geral.clickAndFillField('CDVIATURA', codigo);
		geral.clickAndFillField('NRPLACA', placa);
		geral.selectNative('IDVIAMANUTENCAO', manutencao);
		geral.clickAndFillField('DSTIPOVEIC', nome);
		geral.clickAndFillField('DSMUNICIPIOVIAT', municipio);
		geral.clickAndFillField('SGUFVEICULO', estado);
		geral.searchAndClickGridField('NMFANTTRAN', transportadora, 'NMFANTTRAN', '0');
		geral.searchAndClickGridField('NMMOTORISTA', motorista, 'NMMOTORISTA', '0');
		geral.clickAndFillField('QTCAPACIVIAT', capacidadeKg);
		geral.clickAndFillField('VRFRETEVIATU', frete);
		geral.clickAndFillField('VRVOLUMEVIAT', volume);
		geral.clickAndFillField('QTTARAVIAT', tara);
		geral.selectNative('IDTPRODADO', tipoDeRodado);
		geral.selectNative('IDTPPROPRIETA', tipoProprietario);
		geral.selectNative('IDTPCARROCERIA', tipoDeCarroceria);
		geral.clickAndFillField('QTCAIXASCAPAC', capacidadeCaixa);
	};

	this.adicionaDadosParaCalculo = (quilomentragemMediaAnual, vrMedioLitro, valorIpvaAnual, kmPorLitro,
		valorLicenciamentoAnual, seguroObrigatorioAnual, seguroPrivadoAnual, valorManutencaoMensal) => {
		geral.clickAndFillField('VRKMMEDIAANO', quilomentragemMediaAnual);
		geral.clickAndFillField('VRMEDLTCOMB', vrMedioLitro);
		geral.clickAndFillField('VRIPVAANUAL', valorIpvaAnual);
		geral.clickAndFillField('VRKMMEDLITRO', kmPorLitro);
		geral.clickAndFillField('VRLICENANUAL', valorLicenciamentoAnual);
		geral.clickAndFillField('VRSEGOBANUAL', seguroObrigatorioAnual);
		geral.clickAndFillField('VRSEGPRANUAL', seguroPrivadoAnual);
		geral.clickAndFillField('VRMANUMENSAL', valorManutencaoMensal);
	};

	this.limparCamposOpcionais = (manutencao, tipoDeRodado, tipoProprietario, tipoDeCarroceria) => {
		geral.selectNative('IDVIAMANUTENCAO', manutencao);
		geral.limpaCampoPorId('DSMUNICIPIOVIAT');
		geral.limpaCampoPorId('SGUFVEICULO');
		geral.clickLimparAutoComplete('NMFANTTRAN');
		geral.limpaCampoPorId('QTCAPACIVIAT');
		geral.limpaCampoPorId('VRFRETEVIATU');
		geral.limpaCampoPorId('VRVOLUMEVIAT');
		geral.limpaCampoPorId('QTTARAVIAT');
		geral.selectNative('IDTPRODADO', tipoDeRodado);
		geral.selectNative('IDTPPROPRIETA', tipoProprietario);
		geral.selectNative('IDTPCARROCERIA', tipoDeCarroceria);
		geral.limpaCampoPorId('QTCAIXASCAPAC');
		geral.clickLimparAutoComplete('NMMOTORISTA');
	};

	this.exclui = () => {
		z.component.footer.clickCenterActionByLabel('Deletar');
		// geral.clickExcluir();
		geral.clickSim();
	};
}
module.exports = new Veiculos();
