CREATE OR REPLACE FUNCTION ARQDIGITAL_BLOCOH(
   P_CDIMPOSTO    IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN EMPRESA.CDINSCESTA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_CDLIVROMAG   IN LIVROMAGNETICO.CDLIVROMAG%TYPE) RETURN NUMBER
AS
   V_CONTREGH     NUMBER;
   V_MOVIMENT     NUMBER;
   V_DADOS        VARCHAR2(01);
   V_SEQUPROD     NUMBER;
   V_PRODUTO      VARCHAR2(100);
BEGIN
   V_DADOS := 'N';
   FOR C_REGH020 IN (SELECT ('|H020'                            || '|' ||
                             TO_CHAR(DTINVEFISCAL,'ddmmyyyy')   || '|' ||
                             REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(VRTOTINVFISC),3),0), '999999999990.00')), '.', ',')  || '|'  ) AS ARQ_H020,
                             TO_CHAR(DTINVEFISCAL,'ddmmyyyy') AS DTINVENTFISC
                        FROM INVENTFISC
                       WHERE CDEMPRESA    = P_CDEMPRESA
                         AND CDINSCESTA   = P_CDINSCESTA
                         AND DTINVEFISCAL = P_DTFINAL
                       GROUP BY DTINVEFISCAL) LOOP
      V_DADOS := 'S';
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('53'||LPAD(RTRIM(V_CONTREGH), 8, '0'), C_REGH020.ARQ_H020, P_NRSEQARQMAG);
      V_CONTREGH := NVL(V_CONTREGH,0) + 1;
      FOR C_REGH025 IN (SELECT ('|H025'                                                   || '|' ||
                                '0'                                                       || '|' ||
                                ''                                                        || '|' ||
                                NVL(SUBSTR(R.CDTPITEMPROD,2,1),'')                        || '|' ||  /* identificador do tipo de item */
                                SUBSTR(NVL(NVL(I.CDCLASFISC,P.CDCLASFISC),''),3,9)        || '|' ||
                                NVL(P.CDARVPROD,'')                                       || '|' ||
                                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(I.VRUNIINVFISC,3),0), '999999999990.000')), '.', ',')   || '|' ||
                                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(I.QTESTINVFISC,3),0), '999999999990.000')), '.', ',')   || '|' ||
                                NVL(P.SGUNIDADE,'')                                       || '|' ||
                                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(I.VRTOTINVFISC,2),0), '999999999990.00')), '.', ',')    || '|' ||
                                ''                                                        || '|'  ) AS ARQ_H025,
                                P.CDPRODUTO, P.CDARVPROD
                          FROM INVENTFISC I, PRODUTO P, RELACPRODITGEN R
                         WHERE I.CDEMPRESA    = P_CDEMPRESA
                           AND I.CDINSCESTA   = P_CDINSCESTA
                           AND R.CDLIVROMAG   = '0000000002'
                           AND R.CDPRODUTO    = P.CDPRODUTO
                           AND I.DTINVEFISCAL = C_REGH020.DTINVENTFISC
                           AND I.CDPRODUTO    = P.CDPRODUTO
                           AND I.QTESTINVFISC <> 0) LOOP
         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('54'||LPAD(RTRIM(V_CONTREGH), 8, '0'), C_REGH025.ARQ_H025, P_NRSEQARQMAG);
         V_CONTREGH := NVL(V_CONTREGH,0) + 1;
         /* CODIGO DO PRODUTO */
         SELECT MAX(CDCHAVEREG)
           INTO V_PRODUTO
           FROM TMP_LVELETRONICO
          WHERE CDCHAVEREG = C_REGH025.CDPRODUTO
            AND CDREGISTRO = '0200';
         IF V_PRODUTO IS NULL THEN
            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_LVELETRONICO
              (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1)
            VALUES
              ('0200', V_SEQUPROD, C_REGH025.CDPRODUTO, C_REGH025.CDARVPROD);
         END IF;
      END LOOP;
   END LOOP;
   IF (V_DADOS = 'N') THEN /* a varivel V_DADOS verifica se houve movimento no bloco H */
      V_CONTREGH := NVL(V_CONTREGH,0) + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('53'||LPAD(RTRIM(V_CONTREGH), 8, '0'), '|H020'                         || '|' ||
                                                 TO_CHAR(P_DTFINAL, 'ddmmyyyy') || '|' ||
                                                 0                              || '|'  , P_NRSEQARQMAG);
   END IF;
   /* abertura do bloco H */
   IF ((V_CONTREGH <> 0) AND (V_DADOS <> 'N')) THEN
      V_MOVIMENT := 0;
   ELSE
      V_MOVIMENT := 1;
   END IF;
   V_CONTREGH := NVL(V_CONTREGH,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('52'||LPAD(RTRIM(V_CONTREGH), 8, '0'), '|H001' || '|' ||V_MOVIMENT  || '|' , P_NRSEQARQMAG);
   /* encerramento do bloco H */
   V_CONTREGH := NVL(V_CONTREGH,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG  )
   VALUES
     ('55'||LPAD(RTRIM(V_CONTREGH), 8, '0'), '|H990'|| '|' ||V_CONTREGH   || '|', P_NRSEQARQMAG);
   RETURN(V_CONTREGH);
END;
/

