<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;
use HCM\FPA\ObrigacaoLegal\CNAB\Santander\registro\Registro0CNABSantander;

class FpaCnabmagnet extends \Doctrine\ORM\EntityRepository {
    
    
 public function retornaRegistros($mesCompetencia, $nrOrg, $cdBanco, $nrTipoMovimento, $cdoperinclusao){
        $cnabMagnet = Repositories::FPA_CNABMAGNET;
        $params = array('nrorg' => $nrOrg, 'cdoperador' => $cdoperinclusao, 'dtmescompetenc' => $mesCompetencia, 'cdbanco' => $cdBanco,
        'nrtipomoviment' => $nrTipoMovimento);
        
$sql = <<<SQL
    SELECT c FROM $cnabMagnet c
    WHERE c.nrorg = :nrorg 
    AND c.cdoperinclusao = :cdoperador
    AND c.mescompetencia = :dtmescompetenc
    AND c.nrtipomoviment = :nrtipomoviment
    AND c.cdbanco = :cdbanco
    ORDER BY c.idtpinscestrutu, c.cdinscestrut, c.idtiporegistro, c.nrvinculom, c.idsegmento
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }

    public function retornaRegistrosPorTipo($mesCompetencia, $listaTipoRegistro, $nrOrg, $cdBanco, $nrTipoMovimento, $cdoperinclusao){
        
        $cnabMagnet = Repositories::FPA_CNABMAGNET;
        $params = array('nrorg' => $nrOrg, 'cdoperador' => $cdoperinclusao, 'dtmescompetenc' => $mesCompetencia, 'cdbanco' => $cdBanco,
        'nrtipomoviment' => $nrTipoMovimento, 'nrorginclusao' => $nrOrg);
        
$sql = <<<SQL
    SELECT c FROM $cnabMagnet c
    WHERE c.nrorg = :nrorg 
    AND c.idtiporegistro IN ($listaTipoRegistro)
    AND c.cdoperinclusao = :cdoperador
    AND c.mescompetencia = :dtmescompetenc
    AND c.nrtipomoviment = :nrtipomoviment
    AND c.cdbanco = :cdbanco
    AND c.nrorginclusao = :nrorginclusao
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }

    public function retornaRegistro(
        $mesCompetencia, $nrOrg, $tipoRegistro, $segmento, $tipoInscricao, $nrInscricao, $nrVinculoM, $cdBanco, $nrTipoMovimento, $cdoperinclusao){
        
        $cnabMagnet = Repositories::FPA_CNABMAGNET;
        $params = array('nrorg' => $nrOrg, 'cdoperador' => $cdoperinclusao, 'dtmescompetenc' => $mesCompetencia, 'cdbanco' => $cdBanco,
        'nrtipomoviment' => $nrTipoMovimento, 'nrorginclusao' => $nrOrg, 'idtiporegistro' => $tipoRegistro, 'idsegmento' => $segmento,
        'idtpinscestrutu' => $tipoInscricao, 'nrvinculom' => $nrVinculoM, 'cdinscestrut' => $nrInscricao);
        
$sql = <<<SQL
    SELECT c FROM $cnabMagnet c
    WHERE c.nrorg = :nrorg 
    AND c.idtiporegistro = :idtiporegistro
    AND c.idsegmento = :idsegmento
    AND c.idtpinscestrutu = :idtpinscestrutu
    AND c.cdinscestrut = :cdinscestrut
    AND c.cdoperinclusao = :cdoperador
    AND c.mescompetencia = :dtmescompetenc
    AND c.nrtipomoviment = :nrtipomoviment
    AND c.cdbanco = :cdbanco
    AND c.nrvinculom = :nrvinculom
    AND c.nrorginclusao = :nrorginclusao
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result[0];

    }

    public function totalRegistrosPorTipos($mesCompetencia, $nrOrg, $tiposRegistro, $cdBanco, $nrTipoMovimento, $cdoperinclusao){
        $cnabMagnet = Repositories::FPA_CNABMAGNET;
        $params = array('nrorg' => $nrOrg, 'cdoperador' => $cdoperinclusao, 'dtmescompetenc' => $mesCompetencia, 'cdbanco' => $cdBanco,
        'nrtipomoviment' => $nrTipoMovimento, 'nrorginclusao' => $nrOrg);
        
$sql = <<<SQL
    SELECT count(c) FROM $cnabMagnet c
    WHERE c.nrorg = :nrorg 
    AND c.idtiporegistro IN ($tiposRegistro)
    AND c.cdoperinclusao = :cdoperador
    AND c.mescompetencia = :dtmescompetenc
    AND c.nrtipomoviment = :nrtipomoviment
    AND c.cdbanco = :cdbanco
    AND c.nrorginclusao = :nrorginclusao
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }

    public function retornaUltimoSequencialRegistro0($mesCompetencia, $nrOrg, $cdBanco, $cdoperinclusao){
        
        $cnabMagnet = Repositories::FPA_CNABMAGNET;
        $params = array('nrorg' => $nrOrg, 'cdoperador' => $cdoperinclusao, 'dtmescompetenc' => $mesCompetencia, 'cdbanco' => $cdBanco,
        'nrorginclusao' => $nrOrg, 'tiposRegistro' => Registro0CNABSantander::REGISTRO_0);
        
$sql = <<<SQL
    SELECT max(c.nrsequencialarquivo) FROM $cnabMagnet c
    WHERE c.nrorg = :nrorg 
    AND c.idtiporegistro = :tiposRegistro
    AND c.cdoperinclusao = :cdoperador
    AND c.mescompetencia = :dtmescompetenc
    AND c.cdbanco = :cdbanco
    AND c.nrorginclusao = :nrorginclusao
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }

    public function retornaRegistros0Remessa($mesCompetencia, $nrOrg, $cdBanco, $cdoperinclusao){

        $cnabMagnet = Repositories::FPA_CNABMAGNET;
        $params = array('nrorg' => $nrOrg, 'cdoperador' => $cdoperinclusao, 'dtmescompetenc' => $mesCompetencia, 'cdbanco' => $cdBanco,
        'nrorginclusao' => $nrOrg, 'tiposRegistro' => Registro0CNABSantander::REGISTRO_0);
        
$sql = <<<SQL
    SELECT c FROM $cnabMagnet c
    WHERE c.nrorg = :nrorg 
    AND c.idtiporegistro = :tiposRegistro
    AND c.cdoperinclusao = :cdoperador
    AND c.mescompetencia = :dtmescompetenc
    AND c.cdbanco = :cdbanco
    AND c.nrorginclusao = :nrorginclusao
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }
    
    public function retornaRegistroPorVinculoSegmento($nrOrg, $mesCompetencia, $nrVinculom, $idSegmento, $cdoperinclusao){
        $cnabMagnet = Repositories::FPA_CNABMAGNET;
        $params = array('nrorg' => $nrOrg, 'cdoperador' => $cdoperinclusao, 'dtmescompetenc' => $mesCompetencia, 'nrvinculom' => $nrVinculom,
        'nrorginclusao' => $nrOrg, 'idsegmento' => $idSegmento);
        
$sql = <<<SQL
    SELECT c FROM $cnabMagnet c
    WHERE c.nrorg = :nrorg 
    AND c.idsegmento = :idsegmento
    AND c.cdoperinclusao = :cdoperador
    AND c.mescompetencia = :dtmescompetenc
    AND c.nrvinculom = :nrvinculom
    AND c.nrorginclusao = :nrorginclusao
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result[0];
    }
}