const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const motoristaPage = require('../../../page-objects/parametrizacao/expedicao/motorista.po');
const j = require('../../../json/leitorJson.po');
const motoristaGridId = '1839855890254367871084';
describe('Tela Motorista', () => {
    beforeAll(() => {
        browser.get('http://erpteste.teknisa.com/login/');
        loginPage.login(j.getValor('login'), j.getValor('senha'));
        motoristaPage.abrir();
    });

    afterAll(() => {
        geral.sair();
    });

    it('Deve acessar a tela Motorista', () => {
        expect(z.component.header.getTitle()).toBe('Motorista');
    });

    it('Deve adicionar Motorista', () => {
        geral.clickAdicionar();
        motoristaPage.adicionarMotorista(j.getValor('codigo1'), j.getValor('nomePessoa')
            , j.getValor('matricula'), j.getValor('habilitacao'), j.getValor('nomePessoa'));
        geral.clickSalvar();
        geral.esperarLoading();
        geral.filterIt(j.getValor('codigo1'));
        expect(geral.gridHasText(motoristaGridId, j.getValor('codigo1')))
            .toMatch(j.getValor('codigo1'));
    });

    it('Deve editar Motorista', () => {
        geral.clickGrid('CDMOTORISTA', j.getValor('codigo1'), motoristaGridId);
        geral.clickEditar();
        motoristaPage.editarMotorista(j.getValor('nomePessoa1'), j.getValor('matricula1'),
            j.getValor('habilitacao1'), j.getValor('nomePessoa1'));
        geral.clickSalvar();
        geral.clickVoltar();
        geral.esperarLoading();
        expect(geral.gridHasText(motoristaGridId, j.getValor('nomePessoa1'), 1))
            .toMatch(j.getValor('nomePessoa1'));
    });

    it('Excluir Cadastro', () => {
        geral.clickGrid('CDMOTORISTA', j.getValor('codigo1'), motoristaGridId);
        motoristaPage.apagarMotorista();
        geral.esperarLoading();
        expect(geral.gridHasText(motoristaGridId, j.getValor('codigo1')))
            .toBeUndefined();
    });
});
